from .download import download_zip, download_file
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "blend_file.zip",down_path)
download_zip(xz_url + "dev.zip",down_path)
download_zip(xz_url + "images.zip",down_path)
download_zip(xz_url + "presets.zip",down_path)
download_file(xz_url + "puresky.py",down_path)
download_file(xz_url + "panel.py",down_path)
download_file(xz_url + "handler_post_frame.py",down_path)

bl_info = {
    "name" : "PureSky",
    "author" : "3D Vision, Carlos Barreto",
    "description" : "",
    "blender" : (4, 1, 0),
    "version" : (6, 0, 83),
    "location" : "View3D",
    "warning" : "",
    "category" : "Generic"
}
import bpy
from bpy.props import (PointerProperty)

from . puresky import *
from . panel import *
from . pref import *
# 6.0.83  -   Added option to choose on preferences to have the color management enabled on the panel (this was to solve issue with people using ACES)


classes = (PureSkyPreferences
        ,Append_eevee_Scene,PS_PT_Panel,Colapse,ClipStartDefault
        ,ClipStartOp1,ClipStartOp2,ClipStartOp3,RenderingSetting,NavigatingSetting,PS_MySettings,Apply_ps_config
        ,BDefaultCam,PSDefaultCam, Apply_eevee_preset, Reset_eevee,Append_Cycles_Scene,UpdatePanelValues
        ,UpdateOtherPanelValues
        # ,Apply_cycles_preset
        ,ResetCycles,Append_Stellar_Scene,Apply_stellar_preset,Reset_stellar
        ,UpdatCameraClipend
        ,Apply_cycles_llc_preset,Apply_cycles_sky_preset,ResetCyclesllc,ResetCyclesSky
        ,RemovePuresky,RemovePureskySpace,RemovePureskyStellar,UpdateSkyManagement
        ,Apply_eevee_sky_preset,Apply_eevee_cloud_preset,ResetEeveeSky,ResetEeveeCloud
        ,UpdateVolumeAndSamplesValues,
        UpdatIndividualCameraClipend,SelectCamera,UpdatAllCameraClipend,SetCamera,UpdatCameraPanelClipend
        ,ConnectDisconnectVolumeLink,MuteUnmuteNode,CyclesVolumeQuality
        ,CyclesSurfaceSurfaceSettingsSync,CyclesAtmosphereSettingsSync
        ,CloudType,CyclesFlycamSettingsSync,FlycamSetClearInverse
        ,CyclesSurfaceReset,CyclesVolumeReset,ResetSurfaceAndVolume
        ,AddHDRIImage,ClearHDRIImage
        ,ADM_CyclesGETValues,ADM_TestCode,ADM_CyclesCloudsPresets
        ,ResetCycleshlc,ResetCyclesmlc,ResetCyclessuc
        ,Apply_cycles_hlc_preset,Apply_cycles_mlc_preset,GenerateOtherPresets,Apply_cycles_suc_preset
        ,ResetSinglePanel
        ,Apply_cycles_wind_preset,ResetCyclesWind,Apply_cycles_atm_fog_preset,Apply_cycles_exp_fog_preset
        ,UpdateUnitMetric
)


def update_flycam0(self, context):
    bpy.data.objects["PS_Cycles_World"].constraints["Fly Cam 0"].target = bpy.data.scenes["Scene"].flycam0
    bpy.data.objects["PS_Mist"].constraints["Fly Cam 0"].target = bpy.data.scenes["Scene"].flycam0
    # bpy.data.objects["PS_Cycles_World"].constraints["Fly Cam 0"].target = bpy.data.scenes["Scene"].flycam0
    # bpy.data.objects["PS_Mist"].constraints["Fly Cam 0"].target = bpy.data.scenes["Scene"].flycam0
    # bpy.data.objects['PS_Mist'].modifiers["Fly Camera"]["Input_12"] = bpy.data.scenes["Scene"].flycam0 #trying via handler


# def update_flycam1(self, context):
#     bpy.data.objects["PS_Cycles_World"].modifiers["Fly Camera"]["Input_13"]=bpy.data.scenes["Scene"].flycam1
#     # bpy.data.objects['PS_Mist'].modifiers["Fly Camera"]["Input_13"] = bpy.data.scenes["Scene"].flycam1 #trying via handler



def register():
    ##Custom Icon
    
    import bpy.utils.previews
    pcoll2 = bpy.utils.previews.new()
    my_icons_dir = os.path.join(os.path.dirname(__file__), "icons")
    pcoll2.load("my_icon", os.path.join(my_icons_dir, "icon_LQ.png"), 'IMAGE')
    preview_collections2["main"] = pcoll2

        ####
    ## Part of preview images
    from bpy.types import WindowManager
    from bpy.props import (StringProperty,EnumProperty)

    # Eevee old options, where sky and cloud were together
    WindowManager.ps_previews_dir = StringProperty(name="Folder Path",subtype='DIR_PATH',default="")
    WindowManager.ps_previews = EnumProperty(items=enum_previews_from_directory_items)

    # Eevee sky
    WindowManager.ps_previews_eevee_sky_dir = StringProperty(name="Folder Path",subtype='DIR_PATH',default="")
    WindowManager.ps_previews_eevee_sky = EnumProperty(items=enum_previews_eevee_sky_from_directory_items)
    
    # Eevee Cloud
    WindowManager.ps_previews_eevee_cloud_dir = StringProperty(name="Folder Path",subtype='DIR_PATH',default="")
    WindowManager.ps_previews_eevee_cloud = EnumProperty(items=enum_previews_eevee_cloud_from_directory_items)

    # Fog Previews
    WindowManager.ps_previews_atm_fog_dir = StringProperty(name="Atm Fog Folder Path",subtype='DIR_PATH',default="")
    WindowManager.ps_previews_atm_fog = EnumProperty(items=enum_previews_atm_fog_from_directory_items)

    WindowManager.ps_previews_exp_fog_dir = StringProperty(name="Exp Fog Folder Path",subtype='DIR_PATH',default="")
    WindowManager.ps_previews_exp_fog = EnumProperty(items=enum_previews_exp_fog_from_directory_items)

    #cylces sky and cloud
    WindowManager.ps_previews_sky_dir = StringProperty(name="Sky Folder Path",subtype='DIR_PATH',default="")
    WindowManager.ps_previews_sky = EnumProperty(items=enum_previews_sky_from_directory_items)

    WindowManager.ps_previews_hlc_cloud_dir = StringProperty(name="Cloud Folder Path",subtype='DIR_PATH',default="")
    WindowManager.ps_previews_hlc_cloud = EnumProperty(items=enum_previews_hlc_cloud_from_directory_items)

    WindowManager.ps_previews_mlc_cloud_dir = StringProperty(name="Cloud Folder Path",subtype='DIR_PATH',default="")
    WindowManager.ps_previews_mlc_cloud = EnumProperty(items=enum_previews_mlc_cloud_from_directory_items)

    WindowManager.ps_previews_llc_cloud_dir = StringProperty(name="Cloud Folder Path",subtype='DIR_PATH',default="")
    WindowManager.ps_previews_llc_cloud = EnumProperty(items=enum_previews_llc_cloud_from_directory_items)

    WindowManager.ps_previews_suc_cloud_dir = StringProperty(name="Cloud Folder Path",subtype='DIR_PATH',default="")
    WindowManager.ps_previews_suc_cloud = EnumProperty(items=enum_previews_suc_cloud_from_directory_items)

    WindowManager.ps_previews_cy_wind_dir = StringProperty(name="Wind Folder Path",subtype='DIR_PATH',default="")
    WindowManager.ps_previews_cy_wind = EnumProperty(items=enum_previews_wind_from_directory_items)

    # Note that preview collections returned by bpy.utils.previews
    # are regular Python objects - you can use them to store custom data.
    #
    # This is especially useful here, since:
    # - It avoids us regenerating the whole enum over and over.
    # - It can store enum_items' strings
    #   (remember you have to keep those strings somewhere in py,
    #   else they get freed and Blender references invalid memory!).
    import bpy.utils.previews
    pcoll = bpy.utils.previews.new()
    pcoll.ps_previews_dir = ""
    pcoll.ps_previews = ()
    preview_collections["main"] = pcoll

    pcoll_eevee_sky = bpy.utils.previews.new()
    pcoll_eevee_sky.ps_previews_eevee_sky_dir = ""
    pcoll_eevee_sky.ps_previews_eevee_sky = ()
    preview_collections["main_eevee_sky"] = pcoll_eevee_sky

    pcoll_eevee_cloud = bpy.utils.previews.new()
    pcoll_eevee_cloud.ps_previews_eevee_cloud_dir = ""
    pcoll_eevee_cloud.ps_previews_eevee_cloud = ()
    preview_collections["main_eevee_cloud"] = pcoll_eevee_cloud

    pcoll_sky = bpy.utils.previews.new()
    pcoll_sky.ps_previews_sky_dir = ""
    pcoll_sky.ps_previews_sky = ()
    preview_collections["main_sky"] = pcoll_sky

    pcoll_atm_fog = bpy.utils.previews.new()
    pcoll_atm_fog.ps_previews_atm_fog_dir = ""
    pcoll_atm_fog.ps_previews_atm_fog = ()
    preview_collections["atm_fog"] = pcoll_atm_fog

    pcoll_exp_fog = bpy.utils.previews.new()
    pcoll_exp_fog.ps_previews_exp_fog_dir = ""
    pcoll_exp_fog.ps_previews_exp_fog = ()
    preview_collections["exp_fog"] = pcoll_exp_fog

    pcoll_hlc_cloud = bpy.utils.previews.new()
    pcoll_hlc_cloud.ps_previews_hlc_cloud_dir = ""
    pcoll_hlc_cloud.ps_previews_hlc_cloud = ()
    preview_collections["hlc_cloud"] = pcoll_hlc_cloud

    pcoll_mlc_cloud = bpy.utils.previews.new()
    pcoll_mlc_cloud.ps_previews_mlc_cloud_dir = ""
    pcoll_mlc_cloud.ps_previews_mlc_cloud = ()
    preview_collections["mlc_cloud"] = pcoll_mlc_cloud

    pcoll_llc_cloud = bpy.utils.previews.new()
    pcoll_llc_cloud.ps_previews_llc_cloud_dir = ""
    pcoll_llc_cloud.ps_previews_llc_cloud = ()
    preview_collections["llc_cloud"] = pcoll_llc_cloud

    pcoll_suc_cloud = bpy.utils.previews.new()
    pcoll_suc_cloud.ps_previews_suc_cloud_dir = ""
    pcoll_suc_cloud.ps_previews_suc_cloud = ()
    preview_collections["suc_cloud"] = pcoll_suc_cloud

    pcoll_wind = bpy.utils.previews.new()
    pcoll_wind.ps_previews_cy_wind_dir = ""
    pcoll_wind.ps_previews_cy_wind = ()
    preview_collections["wind"] = pcoll_wind

    ### END _preview images
    ###################


    from bpy.utils import register_class
    for cls in classes:
        register_class(cls)
    bpy.types.Scene.expanded_flycam = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.flycam0 = PointerProperty(type=bpy.types.Object,update = update_flycam0)
    # bpy.types.Scene.flycam1 = PointerProperty(type=bpy.types.Object,update = update_flycam1)
    bpy.types.Scene.puresky_properties = PointerProperty(type=PS_MySettings)
    bpy.types.Scene.button_updt = bpy.props.BoolProperty(default=False) #to use to avoid problems with firing update on panel with update functions
    bpy.types.Scene.expanded_sky_manage = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.expanded_camera_manage = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.expanded_sky = bpy.props.BoolProperty(default=True)
    bpy.types.Scene.expanded_cycle_clouds = bpy.props.BoolProperty(default=True)
    bpy.types.Scene.expanded_fog_preset = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.expanded_atm_fog = bpy.props.BoolProperty(default=True)
    bpy.types.Scene.expanded_exp_fog = bpy.props.BoolProperty(default=True)
    bpy.types.Scene.expanded_cloud = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.expanded_hlc_cloud = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.expanded_mlc_cloud = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.expanded_llc_cloud = bpy.props.BoolProperty(default=True)
    bpy.types.Scene.expanded_suc_cloud = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.expanded_wind_preset = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.vol_mist = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.atm_fog = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.rainbow = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.exp_fog = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.aurora_borealis = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.surface = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.surface_sky = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.surface_sun = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.surface_hdri = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.surface_moon = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.expanded0 = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.expanded1 = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.expanded2 = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.expanded3 = bpy.props.BoolProperty(default=False)
    bpy.types.Scene.expanded4 = bpy.props.BoolProperty(default=True) #options to add puresky to scene
    ###high cloud
    bpy.types.Scene.high_level_cloud = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.hlc_lighting = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.hlc_anime = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.hlc_animate = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.hlc_factors = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.hlc_anvil_drag = bpy.props.BoolProperty(default=False) #options to add puresky to scene--new
    bpy.types.Scene.hlc_cloud_shape = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.hlc_mask = bpy.props.BoolProperty(default=False) #options to add puresky to scene--new
    #Mid Cloud
    bpy.types.Scene.mid_level_cloud = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.md_lighting = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.md_anime = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.md_animate = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.md_factors = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.md_anvil_drag = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.md_cloud_shape = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.md_mask = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    #low cloud
    bpy.types.Scene.low_level_cloud = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.lw_lighting = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.lw_anime = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.lw_animate = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.lw_factors = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.lw_anvil_drag = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.lw_cloud_shape = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.lw_mask = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    #Supercell cloud
    bpy.types.Scene.spc_level_cloud = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.sc_lighting = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.sc_anime = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.sc_animate = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.sc_factors = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.sc_anvil_drag = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.sc_swirl = bpy.props.BoolProperty(default=False) #options to add puresky to scene
    bpy.types.Scene.sc_cloud_shape = bpy.props.BoolProperty(default=False) #options to add puresky to scene

    pre_frame_handlers = bpy.app.handlers.frame_change_pre
    [pre_frame_handlers.remove(h) for h in pre_frame_handlers if h.__name__ == "puresky_frame_handler"]
    pre_frame_handlers.append(puresky_frame_handler)

    pre_handlers = bpy.app.handlers.depsgraph_update_pre
    [pre_handlers.remove(h) for h in pre_handlers if h.__name__ == "puresky_handler"]
    pre_handlers.append(puresky_handler)

def unregister():
    from bpy.utils import unregister_class
    ####
    ## Part of preview images
    from bpy.types import WindowManager

    for pcoll2 in preview_collections2.values():
        bpy.utils.previews.remove(pcoll2)
    preview_collections2.clear()

    del bpy.types.Scene.expanded_flycam
    del bpy.types.Scene.button_updt
    del bpy.types.Scene.surface
    del bpy.types.Scene.surface_sky
    del bpy.types.Scene.surface_sun
    del bpy.types.Scene.surface_moon

    del bpy.types.Scene.vol_mist
    del bpy.types.Scene.atm_fog
    del bpy.types.Scene.rainbow
    del bpy.types.Scene.exp_fog
    del bpy.types.Scene.aurora_borealis

    del WindowManager.ps_previews
    #high cloud
    del bpy.types.Scene.high_level_cloud
    del bpy.types.Scene.hlc_lighting
    del bpy.types.Scene.hlc_anime
    del bpy.types.Scene.hlc_animate
    del bpy.types.Scene.hlc_factors
    del bpy.types.Scene.hlc_anvil_drag
    del bpy.types.Scene.hlc_cloud_shape
    del bpy.types.Scene.hlc_mask
    #mid cloud
    del bpy.types.Scene.mid_level_cloud
    del bpy.types.Scene.md_lighting
    del bpy.types.Scene.md_anime
    del bpy.types.Scene.md_animate
    del bpy.types.Scene.md_factors
    del bpy.types.Scene.md_anvil_drag
    del bpy.types.Scene.md_cloud_shape
    del bpy.types.Scene.md_mask
    #low cloud
    del bpy.types.Scene.low_level_cloud
    del bpy.types.Scene.lw_lighting
    del bpy.types.Scene.lw_anime
    del bpy.types.Scene.lw_animate
    del bpy.types.Scene.lw_factors
    del bpy.types.Scene.lw_anvil_drag
    del bpy.types.Scene.lw_cloud_shape
    del bpy.types.Scene.lw_mask
    #SuperCell cloud
    del bpy.types.Scene.spc_level_cloud
    del bpy.types.Scene.sc_lighting
    del bpy.types.Scene.sc_anime
    del bpy.types.Scene.sc_animate
    del bpy.types.Scene.sc_factors
    del bpy.types.Scene.sc_anvil_drag
    del bpy.types.Scene.sc_swirl
    del bpy.types.Scene.sc_cloud_shape

    for pcoll in preview_collections.values():
        bpy.utils.previews.remove(pcoll)
    preview_collections.clear()
    ### END _preview images
    ###################
    for cls in reversed(classes):
        unregister_class(cls) 
    del bpy.types.Scene.puresky_properties
    pre_frame_handlers = bpy.app.handlers.frame_change_pre
    [pre_frame_handlers.remove(h) for h in pre_frame_handlers if h.__name__ == "puresky_frame_handler"]

    pre_handlers = bpy.app.handlers.depsgraph_update_pre
    [pre_handlers.remove(h) for h in pre_handlers if h.__name__ == "puresky_handler"]






if __name__ == "__main__":
    register()