import bpy

class PureSkyPreferences(bpy.types.AddonPreferences):
    # bl_idname = __name__
    bl_idname = __package__
 
    denoise: bpy.props.EnumProperty(
        items=[
            ('OPTIX', 'Optix', '', '', 0),
            ('OPENIMAGEDENOISE', 'OpenImageDenoise', '', '', 1)
        ],
        default='OPENIMAGEDENOISE'
    )
    bool_color_mngmt: bpy.props.BoolProperty(
        name="Color Management Panel",
        default=False,
    )
 
    def draw(self, context):
        layout = self.layout
        row = layout.row().box()
        row.label(text='Denoise Option:')
        row_col = row.row()
        row_col.prop(self, 'denoise', expand=True)
        
        row = layout.row().box()
        row.label(text='Color Management Panel:')
        row.prop(self, 'bool_color_mngmt', text='Enable Panel',expand=True)